; -----------------------------------------------------------------------------
; ScanKeys
; Escanea las teclas de control y devuelve las pulsadas.
; Salida:	D -> Teclas pulsadas.
;			Bit 0 -> A pulsada 0/1.
;			Bit 1 -> Z pulsada 0/1.
;			Bit 2 -> 0 pulsada 0/1.
;			Bit 3 -> O pulsada 0/1.
; Altera el valor de los registros AF y D.
; -----------------------------------------------------------------------------
ScanKeys:
ld      d, $00          ; Pone el registro D a 0.

scanKeys_A:
ld      a, $fd          ; Carga en A la semi fila A-G
in      a, ($fe)        ; Lee el estado de la semi fila
bit     $00, a          ; Comprueba si se ha pulsado la A
jr      nz, scanKeys_Z  ; Si no se ha pulsado, salta
set     $00, d          ; Pone a 1 el bit correspondiente a la A

scanKeys_Z:
ld      a, $fe          ; Carga en A la semi fila CS-V
in      a, ($fe)        ; Lee el estado de la semi fila
bit	    $01, a          ; Comprueba si se ha pulsado la Z
jr      nz, scanKeys_0  ; Si no se ha pulsado, salta
set     $01, d          ; Pone a 1 el bit correspondiente a la Z

; Comprueba que no se hayan pulsado las dos teclas de dirección
ld      a, d            ; Carga el valor de D en A
sub     $03             ; Resta 3 a A para comprobar si se han pulsado la A y la Z a la vez
jr      nz, scanKeys_0  ; Si no se han pulsado, salta
ld      d, a            ; Pone D a 0

scanKeys_0:
ld      a, $ef          ; Carga la semi fila 0-6
in      a, ($fe)        ; Lee el estado de la semi fila
bit     $00, a          ; Comprueba si se ha pulsado el 0
jr      nz, scanKeys_O  ; Si no se ha pulsado, salta
set     $02, d          ; Pone a 1 el bit correspondiente al 0

scanKeys_O:
ld      a, $cf          ; Carga la semi fila P-Y
in      a, ($fe)        ; Lee el estado de la semi fila
bit     $01, a          ; Comprueba si se ha pulsado la O
ret     nz              ; Si no se ha pulsado, salta
set     $03, d          ; Pone a 1 el bit correspondiente a la O

; Comprueba que no se hayan pulsado las dos teclas de dirección
ld      a, d            ; Carga el valor de D en A
and     $0c             ; Se queda con los bits correspondientes a 0 y O
cp      $0c             ; Comprueba si se han pulsado las dos teclas
ret     nz              ; Si no se han pulsado, sale
xor		d				; Se queda con las pulsaciones de A y Z
ld      d, a            ; Carga el valor en D

ret